import java.awt.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import java.lang.*;
import History;
import StringLinerizer;
import THUser;
import UrlDialog;

import interfaces.AppletBase;
import messages.*;
import consts.Const;
// this is API from CA.
import CAConsts;

public class TH extends AppletBase
{
  public static Room room;
  public String username = "";
  private TextAreal textAreal;
  private String sImageURL = null;
  public History history;
  private Controls controls;
  private Label roomInfo;
  private int Uid = 0;
  private int UidMax = Uid;
  public THUser myself;
  final private int total = 30;

  public void init()
  {
    register();

    setLayout(new BorderLayout());
    setUserName(username);
    room = new Room(this);
    history=new History(this);
    room.addHistory(history);
    textAreal = new TextAreal( this);
    controls = new Controls(this); 
    roomInfo = new Label( "Your name: " + username);
    add( "North", roomInfo);
    add( "Center", room);
    add( "South", textAreal);
    add("East",controls);
    validate();

    byte[] t=new byte[1];
    t[0] = CAConsts.USERNAME;
    AppEventMessage em=new AppEventMessage(Const.CONTROL,t);
    send(em);
  }

public void sendmsg(String msg) {
        try {
          byte[] t=new byte[msg.length()];
          msg.getBytes(0,msg.length(),t,0);
          AppEventMessage em=new AppEventMessage(Const.DATA,t);
          send(em);
        }
        catch (Exception e) {e.printStackTrace();}
}
 
  public void destroy()
  {
    System.out.println("TH destroyed");
    sendmsg(username+":");
    super.destroy();
  }

  public void showHistory()
  {
    history.show();
    controls.history_show();
  }
  
  public void hideHistory()
  {
    history.hide();
    controls.history_hide();
  }

  public Room getRoom()
  {
    return room;
  }

  public void setImageURL( String s) throws Exception
  { URL u;

    if (s == null)
    {
      int nb = (int)(Math.random() * total) + 1;
      u = new URL(getCodeBase(), Integer.toString(nb) + ".gif");
    }
    else {
      u = new URL(getCodeBase(), s);
    }
    sImageURL = u.toString();
  }

synchronized public void NewFace( String sURL)
  {
    try {
      setImageURL( sURL);
      room.newFace( Uid, sImageURL);
      sendmsg(username+"|"+sImageURL);
    }
    catch (Exception e)
    {
      System.err.println( "Bad URL: " + sURL);
      return;
    }
  }

  public void sendText(String text) {
	   //System.out.println(text);
       //System.out.println (username+"## sends text="+text);
	   sendmsg(username+":"+text);
	   room.userSaid(Uid,text);
  }

  public void setUserName(String s) { username=s;}

synchronized public void receive (AppEventMessage em) {
  try {

      if (em.getType() == Const.CONTROL) {
		CAppAnswerEventMessage msg =  (CAppAnswerEventMessage) em;
		if (msg.getAnswerType() == CAConsts.USERNAME) {
                	username = new String(em.getData(),0,1,em.getLen()-1);
                	setUserName(username);
  			roomInfo.setText("Your name: " + username);
                	System.out.println ("me is ####"+username+"#####");
			room.addUser(Uid,username);
			myself = room.getUser(username);
			Point p = myself.getPosition();
			sendmsg(username+"#"+p.x+","+p.y);
		}
      }
      else {
        String msg=new String(em.getData(),0,0,em.getLen());
	int i = msg.indexOf(":"); int j = msg.indexOf("|");	
  	if ((i != -1) && ((j == -1 ) || (j > i))) { //message from another user
		String uname = new String(msg.substring(0,i));
		String msg2 = new String(msg.substring(i+1));
			System.out.println ("message from user "+uname);				
		THUser u = room.getUser(uname);
		if (u != null) {
			System.out.println (username+"## recieves text="+msg2);
 			if (msg2.equals("")) room.userRemove(u.getID());
			else room.userSaid(u.getID(),msg2);
            	}
		else System.err.println( "Bad username " + uname);
		return;
	}

	i = msg.indexOf("#");
	if (i != -1) { // mouse event by another user
		String uname = new String(msg.substring(0,i));
		String tmp = msg.substring(i+1);
		int x = Integer.parseInt(tmp.substring(0,tmp.indexOf(",")));
		int y = Integer.parseInt(tmp.substring(tmp.indexOf(",")+1));
		synchronized (this) {
			UidMax++;
			room.addUser(UidMax,uname,x,y);
		}
		Point p = myself.getPosition();
		
		if (sImageURL != null) sendmsg(username+"|"+p.x+","+p.y+","+sImageURL);
		else sendmsg(username+"|"+p.x+","+p.y);
		return;
	}

	i = msg.indexOf("|");
        if ( i != -1) {	//image URL of a user
		String uname = new String(msg.substring(0,i));
		System.out.println ("!!!new image from"+uname+"#####");
		String tmp = msg.substring(i+1);
		j = tmp.indexOf(",");
		THUser u = room.getUser(uname);
		if (j != -1) { //new position
			if (u != null) return;
			int x = Integer.parseInt(tmp.substring(0,j));
			tmp = tmp.substring(j+1);
		        i = tmp.indexOf(",");
			if (i == -1) { //standard face
				int y = Integer.parseInt(tmp);
				synchronized (this) {
					UidMax++;
					room.addUser(UidMax,uname,x,y);
				}
			}
			else { //new face
				int y = Integer.parseInt(tmp.substring(0,i));
				String uimageUrl = tmp.substring(i+1);			
				System.out.println ("new img is ####"+uimageUrl+"#"+uname);
				synchronized (this) {
					UidMax++;
					room.addUser(UidMax,uname,x,y);
					room.newFace(UidMax,uimageUrl);
				}

			}
		}
		else { //changed to a new face
			if (u == null) return;
			System.out.println ("new img URL is "+tmp+"#"+uname);
			room.newFace(u.getID(),tmp);
		}
		return;
	}

	i = msg.indexOf("^");
	if (i != -1) { // mouse event by another user
		String uname = new String(msg.substring(0,i));
		THUser u = room.getUser(uname);
		String tag = msg.substring(i+1,i+2);
		String tmp = msg.substring(i+2);
		int x = Integer.parseInt(tmp.substring(0,tmp.indexOf(",")));
		int y = Integer.parseInt(tmp.substring(tmp.indexOf(",")+1));
		if (tag.equals("0"))  {//room.mouseDown(u,x,y);
			u.oldx = x;
        		u.oldy = y;
       			//room.userOnTop(u);
        		u.setInMove( true);
        		u.clear( getGraphics());
        		room.updateBorder( getGraphics());
			room.repaint();
			return;
		}
		if (tag.equals("1")) {//room.mouseDrag(x,y);
			int dx = x - u.oldx;
      			int dy = y - u.oldy;	
      			if(!(Math.abs(dx) < 5 && Math.abs(dy) < 5)) {
      				Dimension d=room.size();
      				Rectangle userArea = u.getGlowaArea();
      				//room.userOnTop(u);
      				if (userArea.x + dx <= 0 ) x = u.oldx - userArea.x + 1;
      				if (userArea.y + dy <= 0 ) y = u.oldy - userArea.y + 1;
      				if (userArea.x + userArea.width + dx  >= d.width-2)  
				x = u.oldx + d.width  - (userArea.x + userArea.width) - 2;
      				if (userArea.y + userArea.height + dy >= d.height-2) 
				y = u.oldy + d.height - (userArea.y + userArea.height) - 2;
			
      				u.move( getGraphics(), x-u.oldx, y-u.oldy);
      				u.oldx = x;
      				u.oldy = y;
				room.repaint();
				return;
			}
		}
		if (tag.equals("2")) {//room.mouseUp(x,y);
			int dx = x - u.oldx;
      			int dy = y - u.oldy;	
      			if(!(Math.abs(dx) < 5 && Math.abs(dy) < 5)) {
      				Dimension d=room.size();
      				Rectangle userArea = u.getGlowaArea();
      				//room.userOnTop(u);
      				if (userArea.x + dx <= 0 ) x = u.oldx - userArea.x + 1;
      				if (userArea.y + dy <= 0 ) y = u.oldy - userArea.y + 1;
      				if (userArea.x + userArea.width + dx  >= d.width-2)  
				x = u.oldx + d.width  - (userArea.x + userArea.width) - 2;
      				if (userArea.y + userArea.height + dy >= d.height-2) 
				y = u.oldy + d.height - (userArea.y + userArea.height) - 2;
			
      				u.move( getGraphics(), x-u.oldx, y-u.oldy);
      				u.oldx = x;
      				u.oldy = y;
				//room.repaint();
			}	
			u.moveEnd();
    			u.setInMove( false);
    			u.paint( getGraphics());
			room.repaint();
		}
	}
  }
}
  catch (Exception e) {e.printStackTrace();}
}

}

